local assets =
{	
	Asset("ANIM", "anim/gun.zip"),
	Asset("ANIM", "anim/swap_gun.zip"),
	Asset ("ATLAS", "images/inventoryimages/gun.xml"),
	Asset ("IMAGE", "images/inventoryimages/gun.tex")
}

local prefabs = 
{
	"impact",
}

local function onfinished(inst)
	inst:Remove()
end

local function onequip(inst, owner)
    owner.AnimState:OverrideSymbol("swap_object", "swap_gun", "swap_gun")
    owner.AnimState:Show("ARM_carry") 
    owner.AnimState:Hide("ARM_normal") 
end

local function onunequip(inst, owner)
		if inst:HasTag("reloading") then --reloading in metal gear style. cool.
		inst:RemoveTag("reloading")
		end
    owner.AnimState:Hide("ARM_carry") 
    owner.AnimState:Show("ARM_normal") 
end

local function shoot(inst, attacker, target)

if not inst:HasTag("reloading") then

local pos = Vector3(target.Transform:GetWorldPosition())


local distance = target:GetDistanceSqToInst(attacker)

local range = 0.05*distance --range increases with the increasing of distance.
--max range = approximately 6

local damage = 35 --normal damage

if distance >= 200 then --supposed max distance
damage = damage/5
elseif distance < 200 and distance >= 150 then--supposed medium distance
damage = damage/3
elseif distance < 150 and distance >= 100 then
damage = damage/2
elseif distance < 100 and distance >= 50 then
damage = damage*2
elseif distance < 50 and distance >= 10 then 
damage = damage*3
elseif distance < 10 then
damage = damage*3.5
end

--[[
print("Distance = ", distance)
print("Range = ", range)
print("Damage = ", damage)
--]]
local ents = TheSim:FindEntities(pos.x, pos.y, pos.z, range)

for k,v in pairs(ents) do
        
            if v.components.combat and v ~= GetPlayer() then
				
				v.components.combat:SuggestTarget(attacker)
		
					if damage > 0 then
						v.components.health:DoDelta(-damage)
			
					else
						v.components.health:DoDelta(-1)
					end
			end
				
				if v.sg and v.sg.sg.states.hit then
					v.sg:GoToState("hit")
				end
				
				if v.components.sleeper and v.components.sleeper:IsAsleep() then
						v.components.sleeper:WakeUp()
				end
				
				local hiteffect = SpawnPrefab("impact")
				local pos44 = Vector3(v.Transform:GetWorldPosition())
				hiteffect.Transform:SetPosition(pos44.x, pos44.y, pos44.z)
				
            end

inst:DoTaskInTime(0.25, function()
attacker.AnimState:PlayAnimation("hit") --recoil
end)
	
		 local pt = Vector3(attacker.Transform:GetWorldPosition()) --Old musket's shot effect!
		 
		  attacker:StartThread(function()
			
			local theta = attacker.Transform:GetRotation()*DEGREES
            local radius = 3
			
            local result_offset = FindValidPositionByFan(theta, radius, 12, function(offset)
                local x,y,z = (pt + offset):Get()
                local ents1 = TheSim:FindEntities(x,y,z , 1)
                return not next(ents1) 
            end)
			
			local result_offset2 = FindValidPositionByFan(theta, (radius+2), 12, function(offset2)
                local smokex,smokey,smokez = (pt + offset2):Get()
                local ents2 = TheSim:FindEntities(smokex,smokey,smokez , 1)
                return not next(ents2) 
            end)
			
			local result_offset3 = FindValidPositionByFan(theta, (radius+4), 12, function(offset3)
                local smokexx,smokeyy,smokezz = (pt + offset3):Get()
                local ents3 = TheSim:FindEntities(smokexx,smokeyy,smokezz , 1)
                return not next(ents3) 
            end)
			

            if result_offset then
                local shootFX = SpawnPrefab("impact")
				local shootsmoke1 = SpawnPrefab("small_puff")
				local shootsmoke2 = SpawnPrefab("small_puff")
				
				shootFX.AnimState:SetAddColour(2,2,.2,1)
					shootFX.AnimState:SetBloomEffectHandle( "shaders/anim.ksh" )
						shootFX.AnimState:SetLightOverride(1)
	
			shootsmoke1.AnimState:SetScale(2.2,2.2,2.2)
				shootsmoke1.AnimState:SetMultColour(.2,.2,.2,0.8)
	
			shootsmoke2.AnimState:SetScale(2.5,2.5,2.5)
				shootsmoke2.AnimState:SetMultColour(.2,.2,.2,0.7)
				
                shootFX.Transform:SetPosition((pt + result_offset):Get()) -- Get the right direction to show the smoke <3
				shootsmoke1.Transform:SetPosition((pt + result_offset2):Get())
				shootsmoke2.Transform:SetPosition((pt + result_offset3):Get())
               
            end
    end)
		 
    attacker.SoundEmitter:PlaySound("dontstarve/wilson/fireball_explo")
	
	inst:AddTag("reloading")


else --reloading!

inst.components.finiteuses:Use(-1)

attacker.sg:GoToState("dolongaction")

inst:DoTaskInTime(1, function()
attacker.SoundEmitter:PlaySound("dontstarve/characters/wilton/hurt")
attacker.SoundEmitter:PlaySound("dontstarve/common/cookingpot_open")
attacker.SoundEmitter:PlaySound("dontstarve/wilson/chest_close")
inst:RemoveTag("reloading")
end)

end
end

local function fn(Sim)
	local inst = CreateEntity()
	local trans = inst.entity:AddTransform()
	local anim = inst.entity:AddAnimState()
	inst.entity:AddSoundEmitter()	
    MakeInventoryPhysics(inst)
    
    anim:SetBank("gun")
    anim:SetBuild("gun")
    anim:PlayAnimation("idle")
    
    inst:AddComponent("weapon")
    inst.components.weapon:SetDamage(0.1) 
    inst.components.weapon:SetRange(10)
    inst.components.weapon:SetOnAttack(shoot)
	
	---
    inst:AddComponent("finiteuses")
    inst.components.finiteuses:SetMaxUses(15)
    inst.components.finiteuses:SetUses(15)
    inst.components.finiteuses:SetOnFinished(onfinished)
	    
    inst:AddComponent("inspectable")
    
    inst:AddComponent("inventoryitem")
	inst.components.inventoryitem.atlasname = "images/inventoryimages/gun.xml"
    
    inst:AddComponent("equippable")
    inst.components.equippable:SetOnEquip( onequip )
    inst.components.equippable:SetOnUnequip( onunequip )
	
	inst:AddComponent("characterspecific")
    inst.components.characterspecific:SetOwner("rool")
	
    return inst
end

return Prefab( "common/inventory/gun", fn, assets)