
local MakePlayerCharacter = require "prefabs/player_common"


local assets = {

        Asset( "ANIM", "anim/player_basic.zip" ),
        Asset( "ANIM", "anim/player_idles_shiver.zip" ),
        Asset( "ANIM", "anim/player_actions.zip" ),
        Asset( "ANIM", "anim/player_actions_axe.zip" ),
        Asset( "ANIM", "anim/player_actions_pickaxe.zip" ),
        Asset( "ANIM", "anim/player_actions_shovel.zip" ),
        Asset( "ANIM", "anim/player_actions_blowdart.zip" ),
        Asset( "ANIM", "anim/player_actions_eat.zip" ),
        Asset( "ANIM", "anim/player_actions_item.zip" ),
        Asset( "ANIM", "anim/player_actions_uniqueitem.zip" ),
        Asset( "ANIM", "anim/player_actions_bugnet.zip" ),
        Asset( "ANIM", "anim/player_actions_fishing.zip" ),
        Asset( "ANIM", "anim/player_actions_boomerang.zip" ),
        Asset( "ANIM", "anim/player_bush_hat.zip" ),
        Asset( "ANIM", "anim/player_attacks.zip" ),
        Asset( "ANIM", "anim/player_idles.zip" ),
        Asset( "ANIM", "anim/player_rebirth.zip" ),
        Asset( "ANIM", "anim/player_jump.zip" ),
        Asset( "ANIM", "anim/player_amulet_resurrect.zip" ),
        Asset( "ANIM", "anim/player_teleport.zip" ),
        Asset( "ANIM", "anim/wilson_fx.zip" ),
        Asset( "ANIM", "anim/player_one_man_band.zip" ),
        Asset( "ANIM", "anim/shadow_hands.zip" ),
        Asset( "SOUND", "sound/sfx.fsb" ),
        Asset( "SOUND", "sound/wilson.fsb" ),
        Asset( "ANIM", "anim/beard.zip" ),
		
		Asset( "IMAGE", "images/inventoryimages/gun.tex" ),
        Asset( "ATLAS", "images/inventoryimages/gun.xml" ),

		-- Don't forget to include your character's custom assets!
        Asset( "ANIM", "anim/rool.zip" ),
}

local fn = function(inst)
	STRINGS.CHARACTERS.ROOL = require "speech_rool"
	
	-- choose which sounds this character will play
	inst.soundsname = "wolfgang"

	-- a minimap icon must be specified
	inst.MiniMapEntity:SetIcon( "krok.tex" )

	-- todo: Add an example special power here.
	inst.components.locomotor.walkspeed = (TUNING.WILSON_WALK_SPEED * .6)
	inst.components.locomotor.runspeed = (TUNING.WILSON_RUN_SPEED * 1.2)
	inst.components.sanity:SetMax(60)
	inst.components.health:SetMaxHealth(250)
	inst.components.hunger:SetMax(175)
	inst.components.combat.damagemultiplier = 1.25
	inst.components.hunger:SetRate(TUNING.WILSON_HUNGER_RATE * 1.3)
	inst.Transform:SetScale(1.3, 1.3, 1.3)
	inst.components.temperature.hurtrate = (TUNING.WILSON_HEALTH / TUNING.FREEZING_KILL_TIME) * 2
	
			local function onkilled(victim,inst)
	    if victim and victim.prefab then
		if victim.prefab == "rabbit" and victim.israbbit then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "koalefant" then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "penguin" then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "lightninggoat" then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "babybeefalo" then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "beefalo" then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "smallbird" then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "glommer" then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "butterfly" then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "crow" then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "robin" then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "robin_winter" then
			inst.components.sanity:DoDelta(TUNING.SANITY_SMALL * 0.5)
		elseif victim.prefab == "koalefant" then
			inst.components.sanity:DoDelta(-TUNING.SANITY_SMALL * 0.5)
		end
	    end
	end
			
	inst:ListenForEvent( "killed", function(inst,data) onkilled(data.victim,inst) end )
	
	local gunrecipe = Recipe( "gun", { Ingredient("cutstone",3), Ingredient("gunpowder",3), Ingredient("log",2) }, RECIPETABS.WAR, {SCIENCE = 0,MAGIC = 0,ANCIENT = 0} )
		gunrecipe.atlas = "images/inventoryimages/gun.xml"
	
	inst.components.talker.colour = Vector3(50/255, 104/255, 0/255)
end



return MakePlayerCharacter("rool", prefabs, assets, fn)
